TITLE GENERIC_DLL_MAKES_NOISE
;........................................................................
Prolog MACRO					; 
	mov AX, DS					; must be 1st, since Windows overwrites
	nop						; placeholder for 3rd byte
	inc BP					; push odd BP.  Not required, but
	push BP					; allows CodeView to recognize stack
	mov BP, SP					; set up stack fram to access params
	push DS					; save DS
	mov DS, AX					; point DS to DLL's data segment
	ENDM						; 
;........................................................................
Epilog MACRO					; 
	pop DS					; recover original DS
	pop BP					; and BP + 1
	dec BP					; reset to original BP
	ENDM						; 
;........................................................................
.MODEL small, pascal, farstack		; 
.586							; 
includelib l:\msvc\lib\libw.lib
includelib l:\msvc\lib\sdllcew.lib
	extrn MESSAGEBOX:FAR	
	UINT			TYPEDEF	WORD	
;	extrn UNLOCKSEGMENT:FAR
	@proto_84		TYPEDEF	PROTO FAR PASCAL :UINT
	UnlockSegment	PROTO		@proto_84
;	extrn LOCALINIT:FAR
	@proto_103		TYPEDEF	PROTO FAR PASCAL :UINT, :UINT, :UINT
	LocalInit		PROTO		@proto_103
;........................................................................
.DATA							 
			DB 16 dup(0)		; Required for Task Header!!
	hInstance	DW ?
; for dll function ROAK_NOISE
	szTitle	DB 'Obnoxious DLL Message Box', 0
	szMsg		DB 'Message From Freehafer Is RK NOG!', 10, 13, 'This Is From Inside A Masm 16 Bit DLL.', 0
;........................................................................
.CODE							; 
;........................................................................
; DLLENTRY
;........................................................................
DLLEntry PROC FAR PASCAL PUBLIC		; entry point for DLL DS = data segment and CX = heap size
	mov hInstance, di				; save SI and DI
	push si
	push di					; handle of the module instance
	push ds					; library data segment
	push cx					; heap size
	push es					; command line segment
	push si					; command line offset
;if we have some heap then initialize it
	jcxz @@Init					; jump if no heap specified
;call the Windows function LocalInit() to set up the heap LocalInit((LPSTR)start, WORD cbHeap)
	INVOKE LocalInit, DS, 0, CX		; DS = heap segment, 0 = heap start offset, CX = end offset in segment
	xchg ax,cx
	jcxz @@JmpExit				; quit if it failed
	jmp short @@Init
@@JmpExit:
	jmp @@Exit
@@Init:
@@Main:
	call LIBMAIN				; call DLL's data init routine
	mov di, hInstance				; restore SI and DI
	pop si
	ret
@@Exit:
	mov ax, 0					; set return code
	pop si					; remove arguments to LIBMAIN
	pop es					; since we didn't call it.
	pop cx
	pop ds
	pop di
	pop si					; restore saved SI.  DI is restored
	ret						; by removing arguments to LIBMAIN
DLLEntry        ENDP				; 
;........................................................................
; LIBMAIN
;........................................................................
LibMain PROC FAR PASCAL PUBLIC hinst:word, hdataseg:word, heapsize:word, cmdline:dword
	mov ax, [heapsize]
	or  ax,ax
	jz  @@0001
	invoke UnlockSegment, -1		; unlock the data segment
@@0001:
	mov AX, 1 
	ret						; Return to LibEntry
LibMain ENDP					; 
;........................................................................
OPTION PROLOGUE:None				; disable automatic prolog/epilog
OPTION EPILOGUE:None				; generation for DLL routines
;........................................................................
; NOISE PROCEDURE
;........................................................................
ROAK_NOISE PROC FAR PASCAL EXPORT freq_hi:BYTE, freq_lo:BYTE, duration:WORD 
	Prolog					; 
; display message box				; 
	push 0					; 
	push DS					; 
	mov AX, offset szMsg			; 
	push AX					; 
	push DS					; 
	mov AX, offset szTitle			; 
	push AX					; 
	push 0					; 
	call MessageBox				; 
; get status.............................................................
	in AL, 61h					; get status of 8255 chip
; turn on speaker........................................................
	or AL, 3					; turn on speaker and timer by putting 3 or 
							; 11 binary into accumulator 
							; bit 0 to contorl speaker by timer
							; bit 1 to turn on speaker
	out 61h, AL					; output from accumulator to port B
; make oscilator.........................................................
	mov AL, 0B6h				; set for channel 2 by first putting 0B6h 
							; into accumulator to use timer as oscilator
	out 43h, AL					; output command from register to timer
							; control port chip 8253
; ratio = 1193180/frequency..............................................
	mov AL, freq_lo				; 
	out 42h, AL					; lower byte of result of frequency division is sent to timer port
	mov AL, freq_hi				; 
	out 42h, AL					; higher byte of result of frequency division is sent to timer port
; timer delay............................................................
	mov AX, 91					; generate sound where accumulator contains multiplier
	mul duration				; AX = BX * 91 and result is put in DX:AX since it is a word
	mov BX, 5000				; divisor for milliseconds
	div BX					; DX:AX dividend / 5000 = result in AX, remainder in DX 
	mov BX, AX					; save delay result in BX
	mov AH, 0					; read clock function
	int 1Ah					; read clock interrupt
							; CX:DX incremented 18.206 times per second
	add DX, BX					; DX = DX + BX
	mov BX, DX					; DX = BX
Cycle:						; 
	int 1Ah					; begin loop and read clock interrupt
 	cmp DX, BX					; compare to see if time passed
	jne Cycle					; end loop
; turn off speaker.......................................................
	in AL, 61h					; read mode of port B
	mov AL, 61h					; previous mode of port B
	and AL, 0FCh				; prepare to turn off speaker
	out 61h, AL					; restore original contents to port B to turn speaker off 
	mov AX, 13					; 
	Epilog					; 
	ret						; 
ROAK_NOISE ENDP					; 
;........................................................................
WEP	PROC FAR PASCAL EXPORT wExitCode:WORD
	Prolog					; 
	.IF wExitCode == 1			; WEP_SYSTEM_EXIT unload dll
	.ELSEIF wExitCode == 0			; WEP_FREE_DLL windows is shutting down
	.ENDIF					; 
	mov AX, 1					; Return AX = 1 or TRUE 
	Epilog					; 
	ret						; 
WEP	ENDP						; 
;........................................................................
END 