.586
.model flat, stdcall
option casemap :none
; includes  
	include windows.inc
	include user32.inc
	include kernel32.inc
; library files
	includelib user32.lib
	includelib kernel32.lib	
	includelib undoc32.lib
; prototypes
	LoadLibrary16 PROTO :DWORD
	GetProcAddress16 PROTO :DWORD, :DWORD
	FreeLibrary16 PROTO :DWORD
	QT_THUNK PROTO
;........................................................................
.data
; procedure to display number variables
	OUT_NUMBER				DD 0
	COUNTER				DD 0
	w_std_handle			DD 0
	num_char_written			DD 0
	bytes_to_write			DB 0
; procedure to input number variables
	IN_NUMBER				DD 0
	num_char_read			DD 0
	r_std_handle			DD 0
	bytes_to_read			DB 0
; general variables
	std_handle				DD 0
	input_freq_msg			DB 10, 13, '     INPUT FREQUENCY.  FOR EXAMPLE MIDDLE C = 2600: '
	thunk_return_msg			DB 10, 13, '     L.DLL''s function ROAK_NOISE returned '
	cw_msg				DB '.', 10, 13, 10, 13, '     HIT ENTER KEY TO EXIT . . . '
; kernel32 dll variables
	k32_name				DB 'KERNEL32.DLL', 0
	k32_handle				DD 0
	qt_thunk_name			DB 'QT_Thunk', 0
	qt_thunk_address			DD 0
	thunk_return			DW 0
; 16 bit dll variables
	dll_name				DB 'L.DLL', 0
	dll_handle				DD 0
	function_name			DB 'ROAK_NOISE', 0
	function_address			DD 0
	free_lib				DD 0
; messagbox messages
	err_msg				DB 'ERROR!', 0
	free_lib_msg			DB 'Cannot free handle to 16 bit dll.', 0
	handle_msg				DB 'Cannot load 16 bit dll.', 0
	k32_msg				DB 'Cannot load 32 bit kernel32.dll.', 0
	qt_msg				DB 'Cannot get the address of the function qt_thunk.', 0
	address_msg				DB 'Cannot get the address of the noise function in the dll.', 0
;........................................................................
.code
start:
	invoke GetStdHandle, -11			; 
	mov std_handle, EAX				; 
;........................................................................
	invoke LoadLibrary16, ADDR dll_name		; LOADLIBRARY16
	mov dll_handle, EAX
	.if (dll_handle == 0)
	invoke MessageBox, 0, ADDR handle_msg, ADDR err_msg, 0
	invoke ExitProcess, 0
	.endif
;........................................................................
	invoke GetProcAddress16, dll_handle, ADDR function_name
	mov function_address, EAX
	.if (function_address == 0)
	invoke MessageBox, 0, ADDR address_msg, ADDR err_msg, 0
	invoke ExitProcess, 0
	.endif
;........................................................................
	invoke LoadLibrary, ADDR k32_name
	mov k32_handle, EAX
	.if (k32_handle == 0)
	invoke MessageBox, 0, ADDR k32_msg, ADDR err_msg, 0
	invoke ExitProcess, 0
	.endif
;........................................................................
	invoke GetProcAddress, k32_handle, ADDR qt_thunk_name
	mov qt_thunk_address, EAX
	.if (qt_thunk_address == 0)
	invoke MessageBox, 0, ADDR qt_msg, ADDR err_msg, 0
	invoke ExitProcess, 0
	.endif
;........................................................................
	invoke WriteConsole, std_handle, ADDR input_freq_msg, 54, ADDR num_char_written, 0
	call input_number
	mov EAX, IN_NUMBER
	mov ECX, EAX
	mov EAX, 1193180
	mov EDX, 0
	div CX
	mov BX, AX
	mov EAX, 0
	mov AL, BH
	push EAX
	mov AL, BL
	push EAX
	push 2500						; duration milliseconds
	mov EDX, function_address
	call qt_thunk_address
	mov thunk_return, AX
;........................................................................
	invoke FreeLibrary16, ADDR dll_handle 
	mov free_lib, EAX
;	.if (free_lib == 0)
;	invoke MessageBox, 0, ADDR free_lib_msg, ADDR err_msg, 0
;	invoke ExitProcess, 0
;	.endif
;........................................................................
	invoke WriteConsole, std_handle, ADDR thunk_return_msg, 44, ADDR num_char_written, 0
	mov EAX, 0
	mov AX, thunk_return
	mov OUT_NUMBER, EAX
	call output_number
;........................................................................
; EXIT
;........................................................................ 
	invoke WriteConsole, std_handle, ADDR cw_msg, 38, ADDR num_char_written, 0
;........................................................................
	invoke GetStdHandle, -10			; 
	mov std_handle, EAX				; 
	invoke ReadConsole, std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ReadConsole, std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ExitProcess,0				; 
;........................................................................
;************************************************************************
;*******************************PROCEDURES*******************************
;************************************************************************
;........................................................................
; PROCEDURE TO OUTPUT NUMBER
;........................................................................
output_number proc					; 
	push EAX						; 
	push EBX						; 
	push ECX						; 
	push EDX						; 
	invoke GetStdHandle, -11			; STD_OUTPUT_HANDLE = -11
	mov w_std_handle, EAX				; INVALID_HANDLE_VALUE = -1
	mov EAX, OUT_NUMBER				; number to be displayed
	mov EBX, 10						; 
	mov COUNTER, 0					; recalibrate counter
display_number_loop_next_divide:			; 
	mov EDX, 0						; 
	div EBX						; get next digit in EDX
	push EDX						; store digit 
	inc COUNTER						; 
	cmp EAX, 0						; 
	jne display_number_loop_next_divide		; 
display_number_out_loop:				; 
	pop EDX						; retrieve digit
	add DL, 48						; make a character
	mov bytes_to_write[0], DL			; put character into address
	invoke WriteConsole, w_std_handle, ADDR bytes_to_write, 1, ADDR num_char_written, 0
	dec COUNTER						; 
	.IF (COUNTER > 0)					; 
	jmp display_number_out_loop			; 
	.ENDIF						; 
	pop EDX						; 
	pop ECX						; 
	pop EBX						; 
	pop EAX						; 
	ret							; 
output_number endp					; 
;........................................................................
; PROCEDURE TO INPUT NUMBER
;........................................................................
input_number proc						; 
	push EAX						; 
	push EBX						; 
	push ECX						; 
	push EDX						; 
read_loop: 							; 
	mov EBX, 0						; 
	invoke GetStdHandle, -10			; read one character at a time
	mov r_std_handle, EAX				; 
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read				; 
	cmp AL, 0            				; special character? are not 0 to 9
	jne not_special        				; if not - process character
	jmp short exit_read          			; finished
not_special:						; 
	cmp al,'0'          				; compare character read to "0" (number?)
	jb exit_read					; if not, don't process
	cmp AL, '9'          				; compare character read to "9" (number?)
	ja exit_read					; if not, don't process 
	sub AL, '0'          				; convert character to number
	mov BL, AL           				; copy character read into BX
	mov EAX, IN_NUMBER				; hex number into AX
	mov ECX, 10						; 
	mul ECX             				; one decimal position to the left
	mov IN_NUMBER, EAX				; store result back into memory
	add IN_NUMBER, EBX				; add current hex digit
	jmp short read_loop     	     		; read next character
exit_read:							; 
	pop EDX						; 
	pop ECX						; 
	pop EBX						; 
	pop EAX						; 
	ret							; 
input_number endp						; 
;........................................................................
end start							; 
